/*  
    EQ2Emulator:  Everquest II Server Emulator
    Copyright (C) 2007  EQ2EMulator Development Team (http://www.eq2emulator.net)

    This file is part of EQ2Emulator.

    EQ2Emulator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    EQ2Emulator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with EQ2Emulator.  If not, see <http://www.gnu.org/licenses/>.
*/

//Item Stat defines for ToV Client

//Stat type 6 (blue stats)
#define TOV_ITEM_STAT_HPREGEN				600
#define TOV_ITEM_STAT_MANAREGEN				601
#define TOV_ITEM_STAT_HPREGENPPT			602
#define TOV_ITEM_STAT_MPREGENPPT			603
#define TOV_ITEM_STAT_COMBATHPREGENPPT		604
#define TOV_ITEM_STAT_COMBATMPREGENPPT		605
#define TOV_ITEM_STAT_MAXHP					606
#define TOV_ITEM_STAT_MAXHPPERC				607
#define TOV_ITEM_STAT_MAXHPPERCFINAL		608
#define TOV_ITEM_STAT_SPEED					609
#define TOV_ITEM_STAT_SLOW					610
#define TOV_ITEM_STAT_MOUNTSPEED			611
#define TOV_ITEM_STAT_MOUNTAIRSPEED			612
#define TOV_ITEM_STAT_LEAPSPEED				613
#define TOV_ITEM_STAT_LEAPTIME				614
#define TOV_ITEM_STAT_GLIDEEFFICIENCY		615
#define TOV_ITEM_STAT_OFFENSIVESPEED		616
#define TOV_ITEM_STAT_ATTACKSPEED			617
#define TOV_ITEM_STAT_MAXMANA				618
#define TOV_ITEM_STAT_MAXMANAPERC			619
#define TOV_ITEM_STAT_MAXATTPERC			620
#define TOV_ITEM_STAT_BLURVISION			621
#define TOV_ITEM_STAT_MAGICLEVELIMMUNITY	622
#define TOV_ITEM_STAT_HATEGAINMOD			623
#define TOV_ITEM_STAT_COMBATEXPMOD			624
#define TOV_ITEM_STAT_TRADESKILLEXPMOD		625
#define TOV_ITEM_STAT_ACHIEVEMENTEXPMOD		626
#define TOV_ITEM_STAT_SIZEMOD				627
#define TOV_ITEM_STAT_DPS					628
#define TOV_ITEM_STAT_STEALTH				629
#define TOV_ITEM_STAT_INVIS					630
#define TOV_ITEM_STAT_SEESTEALTH			631
#define TOV_ITEM_STAT_SEEINVIS				632
#define TOV_ITEM_STAT_EFFECTIVELEVELMOD		633
#define TOV_ITEM_STAT_RIPOSTECHANCE			634
#define TOV_ITEM_STAT_PARRYCHANCE			635
#define TOV_ITEM_STAT_DODGECHANCE			636
#define TOV_ITEM_STAT_AEAUTOATTACKCHANCE	637
#define TOV_ITEM_STAT_MULTIATTACKCHANCE		638 //DOUBLEATTACKCHANCE
#define TOV_ITEM_STAT_SPELLMULTIATTACKCHANCE 639
#define TOV_ITEM_STAT_FLURRY				640
#define TOV_ITEM_STAT_MELEEDAMAGEMULTIPLIER	641
#define TOV_ITEM_STAT_EXTRAHARVESTCHANCE	642
#define TOV_ITEM_STAT_EXTRASHIELDBLOCKCHANCE 643
#define TOV_ITEM_STAT_ITEMHPREGENPPT	  	644
#define TOV_ITEM_STAT_ITEMPPREGENPPT		645
#define TOV_ITEM_STAT_MELEECRITCHANCE		646
#define TOV_ITEM_STAT_CRITAVOIDANCE			647
#define TOV_ITEM_STAT_BENEFICIALCRITCHANCE	648
#define TOV_ITEM_STAT_CRITBONUS				649
#define TOV_ITEM_STAT_POTENCY				650 //BASEMODIFIER
#define TOV_ITEM_STAT_UNCONSCIOUSHPMOD		651
#define TOV_ITEM_STAT_ABILITYREUSESPEED		652 //SPELLTIMEREUSEPCT	
#define TOV_ITEM_STAT_ABILITYRECOVERYSPEED	653 //SPELLTIMERECOVERYPCT	
#define TOV_ITEM_STAT_ABILITYCASTINGSPEED	654 //SPELLTIMECASTPCT
#define TOV_ITEM_STAT_SPELLREUSESPEED		655 //SPELLTIMEREUSESPELLONLY
#define TOV_ITEM_STAT_MELEEWEAPONRANGE		656
#define TOV_ITEM_STAT_RANGEDWEAPONRANGE		657
#define TOV_ITEM_STAT_FALLINGDAMAGEREDUCTION 658
#define TOV_ITEM_STAT_RIPOSTEDAMAGE			659
#define TOV_ITEM_STAT_MINIMUMDEFLECTIONCHANCE 660
#define TOV_ITEM_STAT_MOVEMENTWEAVE			661
#define TOV_ITEM_STAT_COMBATHPREGEN			662
#define TOV_ITEM_STAT_COMBATMANAREGEN		663
#define TOV_ITEM_STAT_CONTESTSPEEDBOOST		664
#define TOV_ITEM_STAT_TRACKINGAVOIDANCE		665
#define TOV_ITEM_STAT_STEALTHINVISSPEEDMOD	666
#define TOV_ITEM_STAT_LOOT_COIN				667
#define TOV_ITEM_STAT_ARMORMITIGATIONINCREASE 668
#define TOV_ITEM_STAT_AMMOCONSERVATION		669
#define TOV_ITEM_STAT_STRIKETHROUGH			670
#define TOV_ITEM_STAT_STATUSBONUS			671
#define TOV_ITEM_STAT_ACCURACY				672
#define TOV_ITEM_STAT_COUNTERSTRIKE			673
#define TOV_ITEM_STAT_SHIELDBASH			674
#define TOV_ITEM_STAT_WEAPONDAMAGEBONUS		675
#define TOV_ITEM_STAT_SPELLWEAPONDAMAGEBONUS 676
#define TOV_ITEM_STAT_WEAPONDAMAGEBONUSMELEEONLY   677
#define TOV_ITEM_STAT_ADDITIONALRIPOSTECHANCE   678
#define TOV_ITEM_STAT_PVPTOUGHNESS				680
#define TOV_ITEM_STAT_PVPLETHALITY				681
#define TOV_ITEM_STAT_STAMINABONUS				682
#define TOV_ITEM_STAT_WISDOMMITBONUS			683
#define TOV_ITEM_STAT_HEALRECEIVE				684
#define TOV_ITEM_STAT_HEALRECEIVEPERC			685
#define TOV_ITEM_STAT_PVPCRITICALMITIGATION		686
#define TOV_ITEM_STAT_BASEAVOIDANCEBONUS		687
#define TOV_ITEM_STAT_INCOMBATSAVAGERYREGEN		688
#define TOV_ITEM_STAT_OUTOFCOMBATSAVAGERYREGEN  689
#define TOV_ITEM_STAT_SAVAGERYREGEN				690
#define TOV_ITEM_STAT_SAVAGERYGAINMOD			691
#define TOV_ITEM_STAT_MAXSAVAGERYLEVEL			692
#define TOV_ITEM_STAT_INCOMBATDISSONANCEREGEN   693
#define TOV_ITEM_STAT_OUTOFCOMBATDISSONANCEREGEN 694
#define TOV_ITEM_STAT_DISSONANCEREGEN           695
#define TOV_ITEM_STAT_DISSONANCEGAINMOD         696
#define TOV_ITEM_STAT_AEAUTOATTACKAVOID         697
//End of stat type 6 (blue stats)


//Item stat type 5 (health,power,savagery,dissonance,concentration)
#define TOV_ITEM_STAT_HEALTH				500
#define TOV_ITEM_STAT_POWER					501
#define TOV_ITEM_STAT_CONCENTRATION			502
#define TOV_ITEM_STAT_SAVAGERY			    503
#define TOV_ITEM_STAT_DISSONANCE			504
//End of stat type 5

//Item stat type 3 (damage mods)
#define TOV_ITEM_STAT_DMG_SLASH				300
#define TOV_ITEM_STAT_DMG_CRUSH				301
#define TOV_ITEM_STAT_DMG_PIERCE			302
#define TOV_ITEM_STAT_DMG_HEAT				303
#define TOV_ITEM_STAT_DMG_COLD 				304
#define TOV_ITEM_STAT_DMG_MAGIC				305
#define TOV_ITEM_STAT_DMG_MENTAL			306
#define TOV_ITEM_STAT_DMG_DIVINE			307
#define TOV_ITEM_STAT_DMG_DISEASE			308
#define TOV_ITEM_STAT_DMG_POISON			309
#define TOV_ITEM_STAT_DMG_DROWNING			310
#define TOV_ITEM_STAT_DMG_FALLING			311
#define TOV_ITEM_STAT_DMG_PAIN				312
#define TOV_ITEM_STAT_DMG_MELEE				313
//End of item stat 3

#define TOV_ITEM_STAT_DEFLECTIONCHANCE 		400 //just so no build error

// Other stats not listed above (not sent from the server), never send these to the client
// using type 8 as it is not used by the client as far as we know
#define TOV_ITEM_STAT_DURABILITY_MOD		800
#define TOV_ITEM_STAT_DURABILITY_ADD		801
#define TOV_ITEM_STAT_PROGRESS_ADD			802
#define TOV_ITEM_STAT_PROGRESS_MOD			803
#define TOV_ITEM_STAT_SUCCESS_MOD			804
#define TOV_ITEM_STAT_CRIT_SUCCESS_MOD		805
#define TOV_ITEM_STAT_EX_DURABILITY_MOD		806
#define TOV_ITEM_STAT_EX_DURABILITY_ADD		807
#define TOV_ITEM_STAT_EX_PROGRESS_MOD		808
#define TOV_ITEM_STAT_EX_PROGRESS_ADD		809
#define TOV_ITEM_STAT_EX_SUCCESS_MOD		810
#define TOV_ITEM_STAT_EX_CRIT_SUCCESS_MOD	811
#define TOV_ITEM_STAT_EX_CRIT_FAILURE_MOD	812
#define TOV_ITEM_STAT_RARE_HARVEST_CHANCE	813
#define TOV_ITEM_STAT_MAX_CRAFTING			814
#define TOV_ITEM_STAT_COMPONENT_REFUND		815
#define TOV_ITEM_STAT_BOUNTIFUL_HARVEST		816

#define TOV_ITEM_STAT_STR					0
#define TOV_ITEM_STAT_STA					1
#define TOV_ITEM_STAT_AGI					2
#define TOV_ITEM_STAT_WIS					3
#define TOV_ITEM_STAT_INT					4



#define TOV_ITEM_STAT_ADORNING				100
#define TOV_ITEM_STAT_AGGRESSION			101
#define TOV_ITEM_STAT_ARTIFICING			102
#define TOV_ITEM_STAT_ARTISTRY				103
#define TOV_ITEM_STAT_CHEMISTRY				104
#define TOV_ITEM_STAT_CRUSHING				105
#define TOV_ITEM_STAT_DEFENSE				106
#define TOV_ITEM_STAT_DEFLECTION			107
#define TOV_ITEM_STAT_DISRUPTION			108
#define TOV_ITEM_STAT_FISHING				109
#define TOV_ITEM_STAT_FLETCHING				110
#define TOV_ITEM_STAT_FOCUS					111
#define TOV_ITEM_STAT_FORESTING				112
#define TOV_ITEM_STAT_GATHERING				113
#define TOV_ITEM_STAT_METAL_SHAPING			114
#define TOV_ITEM_STAT_METALWORKING			115
#define TOV_ITEM_STAT_MINING				116
#define TOV_ITEM_STAT_MINISTRATION			117
#define TOV_ITEM_STAT_ORDINATION			118
#define TOV_ITEM_STAT_PARRY     			119
#define TOV_ITEM_STAT_PIERCING     			120
#define TOV_ITEM_STAT_RANGED     			121
#define TOV_ITEM_STAT_SAFE_FALL    			122
#define TOV_ITEM_STAT_SCRIBING     			123
#define TOV_ITEM_STAT_SCULPTING    			124
#define TOV_ITEM_STAT_SLASHING     			125
#define TOV_ITEM_STAT_SUBJUGATION  			126
#define TOV_ITEM_STAT_SWIMMING  			127
#define TOV_ITEM_STAT_TAILORING  			128
#define TOV_ITEM_STAT_TINKERING  			129
#define TOV_ITEM_STAT_TRANSMUTING  			130
#define TOV_ITEM_STAT_TRAPPING  			131
#define TOV_ITEM_STAT_WEAPON_SKILLS			132